]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
we still have to checkout in the screenshot system
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index 6405eb2b1fe7fc62e6f56cdfedddd898cce96729..17ff0e77a4148f3afe63b3a2ecfef12334a582d2 100755 (executable)
@@ -3,23 +3,38 @@
 set -e
 
 bspdir="$PWD/data"
-url=http://141.2.16.23/~xonotic/bsp-autobuilds/
+url_http=http://beta.xonotic.org/autobuild-bsp/
+url_ssh=xonotic-beta:autobuild-bsp/
+build_cachedir="$HOME/xonotic-map-compiler.cache/"
+screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
+build_override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
+screenshot_override="9 600 +g_ctf 1"
 
-bspoutdir="$HOME/public_html/bsp-autobuilds/"
+getthemap_fail=false
 
 allmaps()
 {
-       for F in maps/*.map.options; do
-               if ! [ -f "$F" ]; then
-                       continue
-               fi
-               if ! [ -f "${F%.options}" ]; then
-                       continue
-               fi
-               M=${F#maps/}
-               M=${M%.map.options}
-               blobhash=`git ls-files -s -- "$F" | cut -d ' ' -f 2`-`git ls-files -s -- "${F%.options}" | cut -d ' ' -f 2`
-               "$@" "$M" "$blobhash"
+       commithash=$1
+       shift
+       for F in `git show "${commithash}:maps/"`; do
+               case "$F" in
+                       *.map.options)
+                               ;;
+                       *)
+                               continue
+                               ;;
+               esac
+               M=${F%.map.options}
+               blobhash=`git rev-parse --revs-only "${commithash}:maps/$M.map.options" || true`-`git rev-parse --revs-only "${commithash}:maps/$M.map" || true`
+               case "$blobhash" in
+                       -*)
+                               ;;
+                       *-)
+                               ;;
+                       *)
+                               "$@" "$M" "$blobhash" "$commithash"
+                               ;;
+               esac
        done
 }
 
@@ -38,28 +53,57 @@ pre2spam()
        echo "[$branch $hash] starting map compile of $map"
 }
 
+ss2spam()
+{
+       map=$1
+       url=$2
+       branch=$3
+       hash=$4
+       status=$5
+
+       branch=${branch##refs/heads/}
+       branch=${branch##refs/remotes/}
+       branch=${branch##origin/}
+       hash=`echo "$hash" | cut -c 1-7`
+
+       s_error=
+
+       if [ "$status" -ne 0 ]; then
+               s_error="exited with status $status"
+       fi
+
+       if [ -n "$s_error" ]; then
+               echo "[$branch $hash] \ 34screenshots of $map could not be made: $s_error"
+       else
+               echo "[$branch $hash] screenshots of $map are available on $url"
+       fi
+}
+
 log2spam()
 {
        map=$1
        url=$2
        branch=$3
        hash=$4
+       status=$5
+       time=$6
+
+       hash=`echo "$hash" | cut -c 1-7`
 
        branch=${branch##refs/heads/}
        branch=${branch##refs/remotes/}
        branch=${branch##origin/}
 
-       s_time=
        s_samplesize=
        s_failshaders=
        s_leaked=
        s_error=
 
+       if [ "$status" -ne 0 ]; then
+               s_error="exited with status $status"
+       fi
        while IFS= read -r L; do
                case "$L" in
-                       *\ seconds\ elapsed)
-                               s_time=$(($s_time + ${L%% seconds elapsed}))
-                               ;;
                        WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
                                s=${L##* }
                                if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
@@ -85,9 +129,9 @@ log2spam()
        if [ -n "$s_error" ]; then
                echo -n "[$branch $hash] \ 34failed"
        else
-               echo -n "[$branch] finished"
+               echo -n "[$branch $hash] finished"
        fi
-       echo -n " map compile of $map ($url): $s_time sec"
+       echo -n " map compile of $map ($url): $time sec"
        if [ -n "$s_samplesize" ]; then
                echo -n ", FIX samplesize >= $s_samplesize"
        fi
@@ -110,25 +154,81 @@ log2spam()
 buildthemap()
 {
        REFNAME=$1
-       HASH=$2
-       url=$3
-       bspdir=$4
-       M=$5
-       blobhash=$6
-       if [ -f "$bspdir/$M-$blobhash.pk3" ]; then
+       url=$2
+       M=$3
+       blobhash=$4
+       commithash=$5
+       if HEAD "$url$M-$blobhash.pk3"; then
                continue
        fi
+
+       git reset --hard
+       git clean -xfd
+       git checkout -f "$commithash"
+
        if [ -n "$IRCSPAM" ]; then
-               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM
        fi
+       t0=`date +%s`
        (
                cd maps
-               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` 2>&1 | tee "$M.log"
+               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $build_override > "$M.log"
+       )
+       t1=`date +%s`
+       dt=$(($t1 - $t0))
+       status=$?
+       if [ -n "$IRCSPAM" ]; then
+               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
+       fi
+       zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
+       ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
+       cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
+       zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
+       ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
+       rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
+       rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
+       if [ -n "$IRCSPAM" ]; then
+               $IRCSPAM < "maps/$M.irc"
+       fi
+}
+
+screenshotthemap()
+{
+       REFNAME=$1
+       url=$2
+       M=$3
+       blobhash=$4
+       commithash=$5
+       if HEAD "$url$M-$blobhash/"; then
+               continue
+       fi
+
+       rm -rf ~/.xonotic
+       (
+               cd ../..
+               if [ -n "$DISPLAY" ]; then
+                       misc/tools/xonotic-map-screenshot "$M" $screenshot_override +"scr_screenshot_name \"$M-\""
+               else
+                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"scr_screenshot_name \"$M-\"" -- :8
+               fi
        )
-       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
-       ln -snf "../$M-$blobhash.pk3" "$bspdir/latest/$M.pk3" # from ALL branches, so beware!
+       if ! mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
+               if [ -n "$IRCSPAM" ]; then
+                       #ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 1 > "maps/$M.ircss"
+                       ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > "maps/$M.ircss"
+               fi
+               return 1
+       fi
+       if [ -n "$IRCSPAM" ]; then
+               #ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 0 > "maps/$M.ircss"
+               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > "maps/$M.ircss"
+       fi
+       chmod 1777 "$M-$blobhash"
+       ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
+       rsync -vaSHP "$M-$blobhash" "$url_ssh"
+       rsync -vaSHP "$M" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
-               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+               $IRCSPAM < "maps/$M.ircss"
        fi
 }
 
@@ -139,49 +239,114 @@ getthemap()
        bspdir=$3
        M=$4
        blobhash=$5
+       commithash=$6
        if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
                continue
        fi
        if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
-               rm -f "$bspdir/$M-$blobhash.pk3"
-               echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
-               return 1
+               if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
+                       rm -f "$bspdir/$M-$blobhash.pk3"
+                       echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
+                       getthemap_fail=true
+                       return 0
+               fi
        fi
        if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
-               return 1
+               getthemap_fail=true
+               return 0
        fi
 }
 
+indexthemap()
+{
+       REFNAME=$1
+       M=$2
+       blobhash=$3
+       commithash=$4
+       echo "$M $blobhash $commithash $REFNAME"
+}
+
+rundownload()
+{
+       mkdir -p "$bspdir" "$bspdir.old"
+       for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
+               if [ -e "$b" ]; then
+                       mv "$b" "$bspdir.old"/
+               fi
+       done
+       allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
+}
+
+branches()
+{
+       git for-each-ref 'refs/remotes' | grep -vE '    refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
+}
+
+runmakeindex()
+{
+       cd data/xonotic-maps.pk3dir
+       branches | while read -r HASH TYPE REFNAME; do
+               allmaps "$HASH" indexthemap "$REFNAME"
+       done
+       cd ../..
+}
+
 case "$1" in
        build)
-               mkdir -p "$bspoutdir"
-               mkdir -p "$bspoutdir/latest"
                cd data/xonotic-maps.pk3dir
-               git for-each-ref 'refs/remotes' | while read -r HASH TYPE REFNAME; do
+               branches | while read -r HASH TYPE REFNAME; do
+                       if [ -f "$build_cachedir/$HASH" ]; then
+                               continue
+                       fi
+                       allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
+                       touch "$build_cachedir/$HASH"
+               done
+               git checkout -f master
+               ;;
+       screenshot)
+               runmakeindex > "branches.idx.new"
+               rsync -vaSHP "branches.idx.new" "$url_ssh""branches.idx.new"
+               rm -f "branches.idx.new"
+               cd data/xonotic-maps.pk3dir
+               branches | while read -r HASH TYPE REFNAME; do
+                       if [ -f "$screenshot_cachedir/$HASH" ]; then
+                               continue
+                       fi
+
                        git reset --hard
                        git clean -xfd
-                       git checkout "$HASH"
-                       allmaps buildthemap "$REFNAME" "$HASH" "$url" "$bspoutdir"
+                       git checkout -f "$commithash"
+
+                       rundownload
+                       if $getthemap_fail; then
+                               continue
+                       fi
+
+                       allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
+
+                       touch "$screenshot_cachedir/$HASH"
                done
-               git checkout master
+               git checkout -f master
+               ;;
+       makeindex)
+               runmakeindex
                ;;
        download)
-               mkdir -p "$bspdir" "$bspdir.old"
-               mv "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3 "$bspdir.old"/ || true
                cd data/xonotic-maps.pk3dir
-               allmaps getthemap "$url" "$bspdir.old" "$bspdir"
+               rundownload
+               cd ../..
                echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
-               ls -l "$bspdir.old"
+               ls -l "$bspdir.old" || true
                ;;
        download-latest)
                mkdir -p "$bspdir"
                cd "$bspdir"
                rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
-               wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url""latest"
+               wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
                ;;
        log2spam-test)
-               log2spam "mapname" "http://mapurl" "branch" "commit"
+               log2spam "mapname" "http://mapurl" "branch" "commit" "0"
                ;;
 esac